import{s as Ee,n as Oe,o as He}from"../chunks/scheduler.182ea377.js";import{S as qe,i as Ie,g as d,s as n,r as m,A as Ue,h as a,f as t,c as i,j as P,u as h,x as u,k as M,y as r,a as c,v as g,d as _,t as b,w as v}from"../chunks/index.abf12888.js";import{D as F}from"../chunks/Docstring.b0ac41bc.js";import{H as Le,E as Ve}from"../chunks/EditOnGithub.9b8e78e4.js";function Ae(xe){let p,W,G,J,T,Q,y,$e='The <code>KDPM2DiscreteScheduler</code> is inspired by the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper, and the scheduler is ported from and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',X,w,Se='The original codebase can be found at <a href="https://github.com/crowsonkb/k-diffusion" rel="nofollow">crowsonkb/k-diffusion</a>.',Y,K,Z,o,C,le,U,Pe=`KDPM2DiscreteScheduler is inspired by the DPMSolver2 and Algorithm 2 from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of
Diffusion-Based Generative Models</a> paper.`,ue,V,Me=`This model inherits from <a href="/docs/diffusers/v0.28.0/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/v0.28.0/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,pe,D,k,fe,A,Te=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,me,x,L,he,N,ye="Sets the begin index for the scheduler. This function should be run from pipeline before the inference.",ge,$,E,_e,j,we="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",be,S,O,ve,z,Ke=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,ee,H,Ce="## SchedulerOutput[[diffusers.schedulers.scheduling_utils.SchedulerOutput]]",te,f,q,De,B,ke="Base class for the output of a scheduler’s <code>step</code> function.",se,I,re,R,ne;return T=new Le({props:{title:"KDPM2DiscreteScheduler",local:"kdpm2discretescheduler",headingTag:"h1"}}),K=new Le({props:{title:"KDPM2DiscreteScheduler",local:"diffusers.KDPM2DiscreteScheduler",headingTag:"h2"}}),C=new F({props:{name:"class diffusers.KDPM2DiscreteScheduler",anchor:"diffusers.KDPM2DiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": Union = None"},{name:"use_karras_sigmas",val:": Optional = False"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.KDPM2DiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.00085) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.KDPM2DiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.012) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.KDPM2DiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.KDPM2DiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.KDPM2DiscreteScheduler.use_karras_sigmas",description:`<strong>use_karras_sigmas</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to use Karras sigmas for step sizes in the noise schedule during the sampling process. If <code>True</code>,
the sigmas are determined according to a sequence of noise levels {&#x3C3;i}.`,name:"use_karras_sigmas"},{anchor:"diffusers.KDPM2DiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.KDPM2DiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.KDPM2DiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps, as required by some model families.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.0/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L70"}}),k=new F({props:{name:"scale_model_input",anchor:"diffusers.KDPM2DiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": Tensor"},{name:"timestep",val:": Union"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.KDPM2DiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.0/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L176",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A scaled input sample.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),L=new F({props:{name:"set_begin_index",anchor:"diffusers.KDPM2DiscreteScheduler.set_begin_index",parameters:[{name:"begin_index",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.set_begin_index.begin_index",description:`<strong>begin_index</strong> (<code>int</code>) &#x2014;
The begin index for the scheduler.`,name:"begin_index"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.0/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L166"}}),E=new F({props:{name:"set_timesteps",anchor:"diffusers.KDPM2DiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": int"},{name:"device",val:": Union = None"},{name:"num_train_timesteps",val:": Optional = None"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.KDPM2DiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.0/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L206"}}),O=new F({props:{name:"step",anchor:"diffusers.KDPM2DiscreteScheduler.step",parameters:[{name:"model_output",val:": Union"},{name:"timestep",val:": Union"},{name:"sample",val:": Union"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.KDPM2DiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.KDPM2DiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.KDPM2DiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.KDPM2DiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/v0.28.0/en/api/schedulers/multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput">SchedulerOutput</a> or tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.0/src/diffusers/schedulers/scheduling_k_dpm_2_discrete.py#L362",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If return_dict is <code>True</code>, <a
  href="/docs/diffusers/v0.28.0/en/api/schedulers/multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> is returned, otherwise a
tuple is returned where the first element is the sample tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><a
  href="/docs/diffusers/v0.28.0/en/api/schedulers/multistep_dpm_solver#diffusers.schedulers.scheduling_utils.SchedulerOutput"
>SchedulerOutput</a> or <code>tuple</code></p>
`}}),q=new F({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": Tensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/v0.28.0/src/diffusers/schedulers/scheduling_utils.py#L60"}}),I=new Ve({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/schedulers/dpm_discrete.md"}}),{c(){p=d("meta"),W=n(),G=d("p"),J=n(),m(T.$$.fragment),Q=n(),y=d("p"),y.innerHTML=$e,X=n(),w=d("p"),w.innerHTML=Se,Y=n(),m(K.$$.fragment),Z=n(),o=d("div"),m(C.$$.fragment),le=n(),U=d("p"),U.innerHTML=Pe,ue=n(),V=d("p"),V.innerHTML=Me,pe=n(),D=d("div"),m(k.$$.fragment),fe=n(),A=d("p"),A.textContent=Te,me=n(),x=d("div"),m(L.$$.fragment),he=n(),N=d("p"),N.textContent=ye,ge=n(),$=d("div"),m(E.$$.fragment),_e=n(),j=d("p"),j.textContent=we,be=n(),S=d("div"),m(O.$$.fragment),ve=n(),z=d("p"),z.textContent=Ke,ee=n(),H=d("p"),H.textContent=Ce,te=n(),f=d("div"),m(q.$$.fragment),De=n(),B=d("p"),B.innerHTML=ke,se=n(),m(I.$$.fragment),re=n(),R=d("p"),this.h()},l(e){const s=Ue("svelte-u9bgzb",document.head);p=a(s,"META",{name:!0,content:!0}),s.forEach(t),W=i(e),G=a(e,"P",{}),P(G).forEach(t),J=i(e),h(T.$$.fragment,e),Q=i(e),y=a(e,"P",{"data-svelte-h":!0}),u(y)!=="svelte-1r1y5wx"&&(y.innerHTML=$e),X=i(e),w=a(e,"P",{"data-svelte-h":!0}),u(w)!=="svelte-loovl7"&&(w.innerHTML=Se),Y=i(e),h(K.$$.fragment,e),Z=i(e),o=a(e,"DIV",{class:!0});var l=P(o);h(C.$$.fragment,l),le=i(l),U=a(l,"P",{"data-svelte-h":!0}),u(U)!=="svelte-iytw69"&&(U.innerHTML=Pe),ue=i(l),V=a(l,"P",{"data-svelte-h":!0}),u(V)!=="svelte-sxopj1"&&(V.innerHTML=Me),pe=i(l),D=a(l,"DIV",{class:!0});var ie=P(D);h(k.$$.fragment,ie),fe=i(ie),A=a(ie,"P",{"data-svelte-h":!0}),u(A)!=="svelte-1rkfgpx"&&(A.textContent=Te),ie.forEach(t),me=i(l),x=a(l,"DIV",{class:!0});var oe=P(x);h(L.$$.fragment,oe),he=i(oe),N=a(oe,"P",{"data-svelte-h":!0}),u(N)!=="svelte-1k141rk"&&(N.textContent=ye),oe.forEach(t),ge=i(l),$=a(l,"DIV",{class:!0});var de=P($);h(E.$$.fragment,de),_e=i(de),j=a(de,"P",{"data-svelte-h":!0}),u(j)!=="svelte-1vzm9q"&&(j.textContent=we),de.forEach(t),be=i(l),S=a(l,"DIV",{class:!0});var ae=P(S);h(O.$$.fragment,ae),ve=i(ae),z=a(ae,"P",{"data-svelte-h":!0}),u(z)!=="svelte-hi84tp"&&(z.textContent=Ke),ae.forEach(t),l.forEach(t),ee=i(e),H=a(e,"P",{"data-svelte-h":!0}),u(H)!=="svelte-jslqpb"&&(H.textContent=Ce),te=i(e),f=a(e,"DIV",{class:!0});var ce=P(f);h(q.$$.fragment,ce),De=i(ce),B=a(ce,"P",{"data-svelte-h":!0}),u(B)!=="svelte-6ojmkw"&&(B.innerHTML=ke),ce.forEach(t),se=i(e),h(I.$$.fragment,e),re=i(e),R=a(e,"P",{}),P(R).forEach(t),this.h()},h(){M(p,"name","hf:doc:metadata"),M(p,"content",Ne),M(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),M(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),M($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),M(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),M(o,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),M(f,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,s){r(document.head,p),c(e,W,s),c(e,G,s),c(e,J,s),g(T,e,s),c(e,Q,s),c(e,y,s),c(e,X,s),c(e,w,s),c(e,Y,s),g(K,e,s),c(e,Z,s),c(e,o,s),g(C,o,null),r(o,le),r(o,U),r(o,ue),r(o,V),r(o,pe),r(o,D),g(k,D,null),r(D,fe),r(D,A),r(o,me),r(o,x),g(L,x,null),r(x,he),r(x,N),r(o,ge),r(o,$),g(E,$,null),r($,_e),r($,j),r(o,be),r(o,S),g(O,S,null),r(S,ve),r(S,z),c(e,ee,s),c(e,H,s),c(e,te,s),c(e,f,s),g(q,f,null),r(f,De),r(f,B),c(e,se,s),g(I,e,s),c(e,re,s),c(e,R,s),ne=!0},p:Oe,i(e){ne||(_(T.$$.fragment,e),_(K.$$.fragment,e),_(C.$$.fragment,e),_(k.$$.fragment,e),_(L.$$.fragment,e),_(E.$$.fragment,e),_(O.$$.fragment,e),_(q.$$.fragment,e),_(I.$$.fragment,e),ne=!0)},o(e){b(T.$$.fragment,e),b(K.$$.fragment,e),b(C.$$.fragment,e),b(k.$$.fragment,e),b(L.$$.fragment,e),b(E.$$.fragment,e),b(O.$$.fragment,e),b(q.$$.fragment,e),b(I.$$.fragment,e),ne=!1},d(e){e&&(t(W),t(G),t(J),t(Q),t(y),t(X),t(w),t(Y),t(Z),t(o),t(ee),t(H),t(te),t(f),t(se),t(re),t(R)),t(p),v(T,e),v(K,e),v(C),v(k),v(L),v(E),v(O),v(q),v(I,e)}}}const Ne='{"title":"KDPM2DiscreteScheduler","local":"kdpm2discretescheduler","sections":[{"title":"KDPM2DiscreteScheduler","local":"diffusers.KDPM2DiscreteScheduler","sections":[],"depth":2}],"depth":1}';function je(xe){return He(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Re extends qe{constructor(p){super(),Ie(this,p,je,Ae,Ee,{})}}export{Re as component};
